/*

			Slide Show Screen Saver

*/

#include "screensv.h"

/* Global used by SCRNSAVE.LIB. Required for all screen savers. */

char szAppName[40];

/* Globals exported. */

char szName[] = "Slide Show Screen Saver";

/* Externals defined in SCRNSAVE.LIB. Required for all screen savers. */

extern HINSTANCE hMainInstance;
extern HWND hMainWindow;
char szScreenSaver[22];
char szHelpFile[MAXFILELEN];
char szNoHelpMemory[BUFFLEN];
extern UINT MyHelpMessage;
HOOKPROC fpMessageFilter;

/* RegisterDialogClasses -- Entry point for registering window
							classes required by configuration dialog box. */

BOOL WINAPI RegisterDialogClasses(HANDLE hInst)
{
    return TRUE;
}

//	creditsDialogue  --  Display the credits dialogue

DialogueProc(creditsDialogue)
{
    switch (message) {
        case WM_COMMAND:
            switch (wParam) {
                case IDOK:
                    EndDialog(hDlg, TRUE);
                    return TRUE;

            }
            break;
    }
    return FALSE;
}

/* ScreenSaverConfigureDialog  --  Dialogue box function for
								   screen saver configuration dialogue. */

DialogueProc(ScreenSaverConfigureDialog)
{
	static HWND hIDOK;
	BOOL intok;
	int is;

    switch (message) {
        case WM_INITDIALOG:
            GetIniEntries();
            GetIniSettings();
#ifdef INTERNET_LINKS
			ShowWindow(GetDlgItem(hDlg, IDC_CO_FOURMILAB_STATIC), SW_HIDE);
			ShowWindow(GetDlgItem(hDlg, IDC_CO_FOURMILAB_HOME), SW_SHOW);
#else
			EnableWindow(GetDlgItem(hDlg, IDC_CO_HELP), FALSE);
			ShowWindow(GetDlgItem(hDlg, IDC_CO_FOURMILAB_STATIC), SW_SHOW);
			ShowWindow(GetDlgItem(hDlg, IDC_CO_FOURMILAB_HOME), SW_HIDE);
#endif
			CheckDlgButton(hDlg, IDC_CO_DATE_TIME, showDateTime); 
			CheckDlgButton(hDlg, IDC_CO_FILE_NAME, showFileName); 
			CheckDlgButton(hDlg, IDC_CO_FILE_TYPE, showFileType); 
			CheckDlgButton(hDlg, IDC_CO_PALETTE, forcePalette); 
			CheckDlgButton(hDlg, IDC_CO_ORDER_RANDOM, shufflePlay); 
			CheckDlgButton(hDlg, IDC_CO_ORDER_ALPHA, !shufflePlay);
			CheckDlgButton(hDlg, IDC_CO_POS_RANDOM, randomPosition); 
			CheckDlgButton(hDlg, IDC_CO_POS_CENTRE, !randomPosition);
			SetDlgItemText(hDlg, IDC_CO_PATH, slidePath);
#ifdef INTERNET_FILES
			CheckDlgButton(hDlg, IDC_CO_IGNORE_URL, ignoreInternetShortcuts);
#else
			ShowWindow(GetDlgItem(hDlg, IDC_CO_IGNORE_URL), SW_HIDE);
#endif
			SetDlgItemInt(hDlg, IDC_CO_CHANGE_TIME, changeTime, FALSE);
			CheckDlgButton(hDlg, IDC_CO_SOUND_NEVER, soundMode == SOUND_NEVER); 
			CheckDlgButton(hDlg, IDC_CO_SOUND_SYNC, soundMode == SOUND_SYNC); 
			CheckDlgButton(hDlg, IDC_CO_SOUND_CONT, soundMode == SOUND_CONTINUOUS); 
			CheckDlgButton(hDlg, IDC_CO_SOUND_RETURN, soundMode == SOUND_KEY); 
			SetDlgItemInt(hDlg, IDC_CO_SOUND_PAUSE, soundPause, FALSE);
            hIDOK = GetDlgItem(hDlg, IDOK);
            return TRUE;

        case WM_COMMAND:
            switch (wParam) {
                case IDOK:
					GetDlgItemText(hDlg, IDC_CO_PATH, slidePath, sizeof slidePath);
					showDateTime = IsDlgButtonChecked(hDlg, IDC_CO_DATE_TIME);
					showFileName = IsDlgButtonChecked(hDlg, IDC_CO_FILE_NAME);
					showFileType = IsDlgButtonChecked(hDlg, IDC_CO_FILE_TYPE);
					forcePalette = IsDlgButtonChecked(hDlg, IDC_CO_PALETTE);
					shufflePlay = IsDlgButtonChecked(hDlg, IDC_CO_ORDER_RANDOM);
					randomPosition = IsDlgButtonChecked(hDlg, IDC_CO_POS_RANDOM);
#ifdef INTERNET_FILES
					ignoreInternetShortcuts = IsDlgButtonChecked(hDlg, IDC_CO_IGNORE_URL);
#endif
					if (IsDlgButtonChecked(hDlg, IDC_CO_SOUND_NEVER)) {
						soundMode = SOUND_NEVER;
					}
					if (IsDlgButtonChecked(hDlg, IDC_CO_SOUND_SYNC)) {
						soundMode = SOUND_SYNC;
					}
					if (IsDlgButtonChecked(hDlg, IDC_CO_SOUND_CONT)) {
						soundMode = SOUND_CONTINUOUS;
					}
					if (IsDlgButtonChecked(hDlg, IDC_CO_SOUND_RETURN)) {
						soundMode = SOUND_KEY;
					}

					is = GetDlgItemInt(hDlg, IDC_CO_CHANGE_TIME, &intok, FALSE);
					if (intok) {
						changeTime = is;
					} else {
						changeTime = 60;
					}
					is = GetDlgItemInt(hDlg, IDC_CO_SOUND_PAUSE, &intok, FALSE);
					if (intok) {
						soundPause = is;
					} else {
						soundPause = 15;
					}

					/*	If the user supplied a trailing slash or
						backslash on the directory name, prune it.  */

					while ((strlen(slidePath) > 0) &&
							((slidePath[strlen(slidePath) - 1] == '/') ||
							 (slidePath[strlen(slidePath) - 1] == '\\'))) {
						slidePath[strlen(slidePath) - 1] = 0;	
					}
					if (strlen(slidePath) == 0) {
						strcpy(slidePath, rstring(IDS_DEFAULT_PATH));
					}

					/* Store all configuration parameters in the registry. */
					
                    {
						HKEY keyh;
						DWORD dispos;
						TCHAR keyname[80];
						
						strcpy(keyname, "Software\\Fourmilab.ch\\");
						strcat(keyname, szAppName);
						if (RegCreateKeyEx(HKEY_CURRENT_USER,
									keyname,					// Subkey name
									0,							// Reserved
									"",							// Bogus class string
									REG_OPTION_NON_VOLATILE,	// Options
									KEY_ALL_ACCESS,				// Access rights			
									NULL,						// Security attributes
									&keyh,						// Returned handle to the key
									&dispos) == ERROR_SUCCESS) { // Returned disposition
#define regStore(name, value) RegSetValueEx(keyh, rstring(name), 0, REG_DWORD, (BYTE *) &value, sizeof(value))
#define regStoreS(name, value) RegSetValueEx(keyh, rstring(name), 0, REG_SZ, (BYTE *) value, lstrlen(value) + 1)
								regStore(INI_DATE_TIME, showDateTime);  
								regStore(INI_FILE_NAME, showFileName);
								regStore(INI_FILE_TYPE, showFileType);
								regStore(INI_PALETTE, forcePalette);
								regStore(INI_SHUFFLE, shufflePlay);
								regStore(INI_SCREENPOS, randomPosition);
								regStore(INI_CHANGETIME, changeTime);
								regStore(INI_SOUNDMODE, soundMode);
								regStore(INI_SOUNDPAUSE, soundPause);
								regStoreS(INI_PATH, slidePath);
#ifdef INTERNET_FILES
								regStore(INI_IGNOREURL, ignoreInternetShortcuts);
#endif

								RegCloseKey(keyh);
						}
                   }
#undef regStore
#undef regStoreS

                    EndDialog(hDlg, TRUE);
                    return TRUE;

                case IDCANCEL:
                    EndDialog(hDlg, FALSE);
                    return TRUE;

				case IDC_CO_FILE_BROWSE:
					{
						OPENFILENAME ofn;
						static char ofilt[] =
							"Images and sound files\0"
#ifdef INTERNET_FILES
							"*.url;"
#endif
							"*.jpg;*.gif;*.png;*.bmp;*.wav;*.mid;*.rmi\0"
							"All files (*.*)\0" "*.*\0\0";
						char browsepath[MAX_PATH];
						
						GetDlgItemText(hDlg, IDC_CO_PATH, browsepath, sizeof browsepath);
						ofn.lStructSize = sizeof(OPENFILENAME);
						ofn.hwndOwner = hDlg; 
						ofn.hInstance = NULL;
						ofn.lpstrFilter = ofilt; 
						ofn.lpstrCustomFilter = NULL;
						ofn.nMaxCustFilter = 0; 
						ofn.nFilterIndex = 1;
						ofn.lpstrFile = browsepath; 
						ofn.nMaxFile = MAX_PATH;
						ofn.lpstrFileTitle = NULL; 
						ofn.nMaxFileTitle = 0;
						ofn.lpstrInitialDir = NULL; 
						ofn.lpstrTitle = rstring(IDS_OPENTITLE);
						ofn.Flags = OFN_HIDEREADONLY | OFN_NOCHANGEDIR |
							OFN_PATHMUSTEXIST; 
						ofn.nFileOffset = 0;
						ofn.nFileExtension = 0; 
						ofn.lpstrDefExt = NULL;
						ofn.lCustData = 0L; 
						ofn.lpfnHook = NULL;
						ofn.lpTemplateName = NULL; 
						if (GetOpenFileName(&ofn)) {
							if (ofn.nFileOffset > 0) {
								browsepath[ofn.nFileOffset - 1] = 0;
							}
							SetDlgItemText(hDlg, IDC_CO_PATH, browsepath);
						}	
						return TRUE;
					}

#ifdef INTERNET_LINKS
				case IDC_CO_FOURMILAB_HOME:
					HlinkNavigateString(NULL, L"http://www.fourmilab.ch/");
					return TRUE;
					

				case IDC_CO_HELP:
DoHelp:				HlinkNavigateString(NULL, L"http://www.fourmilab.ch/slidescr/");
					return TRUE;					
#else

                case ID_HELP:
DoHelp:
                    MessageBox(hDlg, "Slide Show screen saver.", szName, MB_OK);
                    break;
#endif

				case IDC_CO_CREDITS:
					DialogBox(hMainInstance, MAKEINTRESOURCE(DLG_CREDITS),
						hDlg, creditsDialogue);
					return TRUE;
            }
            break;

        default:
            if (message == MyHelpMessage)     // Context sensitive help msg.
                goto DoHelp;
    }
    return FALSE;
}

/* GetIniSettings -- Get initial settings from WIN.INI

	Params:  hWnd -- Handle to window

	Return:  None
	
	Note that initial installation defaults are set by the default
	arguments to the retrievals of the profile variables.
*/

void GetIniSettings(void)
{
	HKEY keyh;
	TCHAR keyname[80];
	
	strcpy(keyname, "Software\\Fourmilab.ch\\");
	strcat(keyname, szAppName);

	if (RegOpenKeyEx(HKEY_CURRENT_USER,
			keyname,				// Subkey name
			0,						// Reserved
			KEY_QUERY_VALUE,		// Security access mask
			&keyh) == ERROR_SUCCESS) {
		DWORD vsize;

#define regGet(name, value) vsize = sizeof(value); RegQueryValueEx(keyh, rstring(name), NULL, NULL, (BYTE *) &value, &vsize)
#define regGetS(name, value) vsize = sizeof(value); RegQueryValueEx(keyh, rstring(name), NULL, NULL, (BYTE *) value, &vsize)

		regGet(INI_DATE_TIME, showDateTime);
		regGet(INI_FILE_NAME, showFileName);
		regGet(INI_FILE_TYPE, showFileType);
		regGet(INI_PALETTE, forcePalette);
		regGet(INI_SHUFFLE, shufflePlay);
		regGet(INI_SCREENPOS, randomPosition);
		regGet(INI_CHANGETIME, changeTime);
		regGet(INI_SOUNDMODE, soundMode);
		regGet(INI_SOUNDPAUSE, soundPause);
		regGetS(INI_PATH, slidePath);
#ifdef INTERNET_FILES
		regGet(INI_IGNOREURL, ignoreInternetShortcuts);
#endif
		
		RegCloseKey(keyh);
#undef regGet
#undef regGetS
	} else {
		showDateTime = TRUE;
		showFileName = FALSE;
		showFileType = TRUE;
		forcePalette = FALSE;
		shufflePlay = TRUE;
		randomPosition = TRUE;
		changeTime = 60;
		soundMode = SOUND_CONTINUOUS;
		soundPause = 15;
		strcpy(slidePath, rstring(IDS_DEFAULT_PATH));
#ifdef INTERNET_FILES
		ignoreInternetShortcuts = FALSE;
#endif
	}
}

//	Load common strings from the string table resource

void GetIniEntries(void)
{
    LoadString(hMainInstance, idsAppName, szAppName, 40); 
	LoadString(hMainInstance, idsScreenSaver, szScreenSaver, 22);
	LoadString(hMainInstance, idsHelpFile, szHelpFile, MAXFILELEN);
	LoadString(hMainInstance, idsNoHelpMemory, szNoHelpMemory, BUFFLEN);
}
